if not modules then modules = { } end modules ['t-annotation'] = {
    version   = 1.000,
    comment   = "Annotations",
    author    = "Wolfgang Schuster",
    copyright = "Wolfgang Schuster",
    license   = "GNU General Public License"
}

thirddata            = thirddata            or {}
thirddata.annotation = thirddata.annotation or {}

local annotation = thirddata.annotation

annotation.empty = true

function annotation.open()
    annotation.export = io.open(file.addsuffix(table.concat({tex.jobname,"annotation"},"-"),"txt"),"wb")
end

function annotation.write(title,content)
    local title, content = title:strip(), content
    if annotation.empty == true then
        annotation.open()
        annotation.empty = false
    else
        annotation.export:write("\n\n")
    end
    if title ~= "" then
        annotation.export:write(title)
        annotation.export:write("\n",string.rep("-",#title),"\n\n")
        content = content:gsub(" \\par ","\n\n")
        content = content:gsub("\\ignorespaces ","")
        annotation.export:write(content)
    end
end

--~ function annotation.write(title,content)
--~     local title, content = title:strip(), content
--~     if annotation.empty == true then
--~         annotation.open()
--~         annotation.empty = false
--~     else
--~         annotation.export:write("\n")
--~     end
--~     annotation.export:write(title.." "..content)
--~ end

annotation.data = { }

function annotation.erasedata()
    annotation.data = nil
end

function annotation.getdata()
    return annotation.data or ""
end

function annotation.collectdata(content,begintag,endtag)
    local data    = annotation.getdata()
    local nesting = false
    if data == "" then
        annotation.data = content
    else
        annotation.data = data .. "\\" .. endtag .. " " .. content
    end
    if select(2,string.gsub(annotation.data,begintag,begintag)) > select(2,string.gsub(annotation.data,endtag,endtag)) then
        nesting = true
    else
        nesting = false
    end
    commands.testcase(nesting)
end
